{bpascal.ru}
Uses
  Graph, CRT;

Type point = record
           x,y : Integer;
     end;

Var
  grDriver : Integer;
  grMode   : Integer;
  A,B : Point;
  L : Integer;

function IntToStr(i: Longint): string;
{ Convert any Integer type to a string }
var
  s: string[11];
begin
  Str(i, s);
  IntToStr := s;
end;

Procedure Draw(B,E : Point);
Begin
     Line(B.x, B.y, E.x, E.y);
End;

Procedure Fractal(A,B : Point; Level : Integer);
Var C,D,E,F,e1,f1,G : Point;
Begin
     C.x := Trunc((B.x-A.x)/3 + A.x);
     C.y := Trunc((B.y-A.y)/3 + A.y);

     D.x := Trunc(B.x - (B.x-A.x)/3);
     D.y := Trunc(B.y - (B.y-A.y)/3);

     E1.x := A.y;
     E1.y := B.x;

     E.x := B.y;
     E.y := A.x;

     F.x := Trunc((B.x-A.x)/2 + A.x);
     F.y := Trunc((B.y-A.y)/2 + A.y);

     F1.x := Trunc(F.x + (E1.x - E.x));
     F1.y := Trunc(F.y + (E1.y - E.y));

     G.x := Trunc(F.x + (F1.x-F.x)/3);
     G.y := Trunc(F.y + (F1.y-F.y)/3);

     If Level = 0 Then Begin
        Draw(A,C);
        Draw(C,G);
        Draw(G,D);
        Draw(D,B);
     End Else Begin
         Fractal(A,C,Level-1);
         Fractal(C,G,Level-1);
         Fractal(G,D,Level-1);
         Fractal(D,B,Level-1);
     End;
End;

Begin

     Write('L=');
     ReadLn(L);

     grDriver := Detect;
     InitGraph(grDriver,grMode,'C:\TP\BGI\');

     A.x := GetMaxX;
     A.y := GetMaxY-100;

     B.x := 000;
     B.y := GetMaxY-100;

     Fractal(A,B,L);

     ReadLn;
     CloseGraph;
End.
